`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    17:53:08 01/05/2017 
// Design Name: 
// Module Name:    Lin_cordic 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependenies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
/////////////////////////////////////////////////////////////////////////////////
module CORDIC_vec #(parameter N=18,zro =18'b000000000000000000)
    (x,y,x_out,y_out,clk,reset,start_op,end_op);
input [N-1:0] x,y;
input clk,reset,start_op;
output [N-1:0] x_out,y_out;
output end_op;

wire [N-1:0 ] x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16,x17,x18,x19,x20,x21;
wire [N-1:0 ] y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,y12,y13,y14,y15,y16,y17,y18,y19,y20,y21;
wire tc1,tc2,tc3,tc4,tc5,tc6,tc7,tc8,tc9,tc10,tc11,tc12,tc13,
tc14,tc15,tc16,tc17,tc18,tc19,tc20,tc21,s,s1,s2,s3;

stage #(N,0) c0(x1,y1,x,y,clk,reset,start_op,tc1);
stage #(N,1) c1(x2,y2,x1,y1,clk,reset,tc1,tc2);
stage #(N,2) c2(x3,y3,x2,y2,clk,reset,tc2,tc3);
stage #(N,3) c3(x4,y4,x3,y3,clk,reset,tc3,tc4);
stage #(N,4) c4(x5,y5,x4,y4,clk,reset,tc4,tc5);
stage #(N,5) c5(x6,y6,x5,y5,clk,reset,tc5,tc6);
stage #(N,6) c6(x7,y7,x6,y6,clk,reset,tc6,tc7);
stage #(N,7) c7(x8,y8,x7,y7,clk,reset,tc7,tc8);
stage #(N,8) c8(x9,y9,x8,y8,clk,reset,tc8,tc9);
stage #(N,9) c9(x10,y10,x9,y9,clk,reset,tc9,tc10);
stage #(N,10) c10(x11,y11,x10,y10,clk,reset,tc10,tc11);
stage #(N,11) c11(x12,y12,x11,y11,clk,reset,tc11,tc12);
stage #(N,12) c12(x13,y13,x12,y12,clk,reset,tc12,tc13);
stage #(N,13) c13(x14,y14,x13,y13,clk,reset,tc13,tc14);
stage #(N,14) c14(x15,y15,x14,y14,clk,reset,tc14,tc15);
stage #(N,15) c15(x16,y16,x15,y15,clk,reset,tc15,tc16);
stage #(N,16) c16(x17,y17,x16,y16,clk,reset,tc16,tc17);
//stage #(N,17) c17(x18,y18,x17,y17,clk,reset,tc17,tc18);

regN #(N) Reg1(x19,clk,reset,x17);
regN #(N) Reg2(y19,clk,reset,y17);
DFF f1(tc19,clk,reset,tc17);
/////Compensation..........and delay matching...
scale_block #(N) sb1(x19,x20,clk,reset);
scale_block #(N) sb2(y19,y20,clk,reset);
DFF f2(tc20,clk,reset,tc19);
DFF f3(tc21,clk,reset,tc20);
////Delay after compensation...
DFF f4(end_op,clk,reset,tc21);
regN #(N) Reg7(x21,clk,reset,x20);
regN #(N) Reg8(y21,clk,reset,y20);
///inversion of Output..........
adsubN #(N) a1(s3,zro,x21,x_out);
adsubN #(N) a2(s3,zro,y21,y_out);
//////Delay for MSB of X...............
general_delay_block #(1,21) dl3(clk,reset,x[N-1],s3);
///Optional output register...
//DFF f5(end_op,clk,reset,tc20);
//regN #(N) Reg9(x_out,clk,reset,x20);
//regN #(N) Reg10(y_out,clk,reset,y20);////delay of 20 clock cycles...................
endmodule

module stage #(parameter N=16,p=1)
                (x,y,a,b,clk,reset,start,start1);
    input [N-1:0] a,b;
    output [N-1:0] x,y;
    input clk,reset,start;
	 output start1;
    
wire [N-1:0] x1,x2,y1,y2;
wire s;
regN #(N) Reg1(x1,clk,reset,a);
regN #(N) Reg2(y1,clk,reset,b);
DFF d1(start1,clk,reset,start);
SB m1(clk,reset,start1,(x1[N-1]^y1[N-1]),s);

RSH_wired #(N,p) sh1(x1,x2);
RSH_wired #(N,p) sh2(y1,y2);

adsubN #(N) Ads1(s,x1,y2,x);
adsubN #(N) Ads2(~s,y1,x2,y);
endmodule

module scale_block #(parameter N=16)(a,b,clk,reset);
 
	 wire [N-1:0] t1,t2,t3,t4,t5,t6,t8,t9,t10,t11,t12,t13,t14,t15,t16;
	 //parameter reset = 1'b0;
	 input clk,reset;
	 input [N-1:0] a;
	 output [N-1:0] b;
	 
RSH_wired #(N,1) r1(a,t1);
RSH_wired #(N,4) r2(a,t2);
RSH_wired #(N,5) r3(a,t3);
RSH_wired #(N,7) r4(a,t4);
RSH_wired #(N,8) r5(a,t5);
RSH_wired #(N,10) r6(a,t6);

adsubN #(N) a1(1'b0,t1,t2,t8);
adsubN #(N) a2(1'b0,t3,t4,t9);
adsubN #(N) a3(1'b0,t5,t6,t10);

regN #(N) d1(t11,clk,reset,t8);
regN #(N) d2(t12,clk,reset,t9);
regN #(N) d3(t13,clk,reset,t10);

adsubN #(N) a4(1'b0,t11,t12,t14);

regN #(N) d5(t15,clk,reset,t14);
regN #(N) d6(t16,clk,reset,t13);

adsubN #(N) a5(1'b0,t15,t16,b);
endmodule

module RSH_wired #(parameter N = 18, p = 10)(a,b);
    input [N-1:0] a;
    output [N-1:0] b;
    //output [p-1:0] rm;
	 integer i;
	 reg [p:0] c;
//assign rm = a[p-1:0];
assign b[N-1-p-1:0]= a[N-2:p];
assign b[N-1:N-1-p] = c;
always @*
for (i= 0; i<=p; i = i+1) begin
c[i] = a[N-1];
end
endmodule

module general_delay_block #(parameter N=1,
									  parameter D = 4)(clk,reset,a,aN);
input clk,reset;
input [N-1:0] a;
output [N-1:0] aN;
wire [N-1:0] tmp [D:0];
assign tmp[0] = a;
generate
genvar p;
for (p = 1; p <= D; p = p+1) begin: General_delay
regN #(N) rg(tmp[p],clk,reset,tmp[p-1]);
end
endgenerate
assign aN = tmp[D];
endmodule

module adsubN #(parameter N = 18)(input sel,input [N-1:0] a,b,
output [N-1:0] s
    );
assign s = (sel)?(a-b):(a+b);

endmodule

module regN #(parameter N=18)(y,clk,reset,a);
    input [N-1:0] a;
    output reg [N-1:0] y;
    input clk,reset;
 
always @(posedge clk)
if (reset)
y <= 0;
else
y <= a;
endmodule

module DFF(q,clk,reset,d);
    input d,clk,reset;
    output reg q;
initial begin q=0; end
always @ (posedge (clk)) begin
 if (reset)
  q <= 0;
 else  
 q<= d ;
end
endmodule

module FDC(q,clk,reset,en,d);
    input d,clk,reset,en;
    output reg q;
initial begin q=0; end
always @ (posedge (clk)) begin
 if (reset)
  q <= 0;
 else if (en) 
 q <= d ;
 else 
 q <= q;
end
endmodule

module MuxNbit_2_1 #(parameter N=18)(a,b,s,y);
    input [N-1:0] a,b;
	 input s;
    output [N-1:0] y;
assign y = (s)?(b):(a);
endmodule

module SB(clk,reset,en,a,b);
input clk,reset,a,en;
output b;
wire q;
FDC m1(q,clk,reset,en,a);
MuxNbit_2_1 #(1) mx(q,a,en,b);
endmodule