`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 13.02.2023 13:58:21
// Design Name: 
// Module Name: QR_part2test
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module QR_part2test #(parameter N=18,M=3)
        (clk,reset,start,R1out,R2out,R3out,R4out,R5out,R6out,R7out,R8out);
input clk,reset,start;
output [N-1:0] R1out,R2out,R3out,R4out,R5out,R6out,R7out,R8out;
wire [N-1:0] R1,R2,R3,R4,R5,R6,R7,R8;
wire ena,tc,start1,start2;
wire [M-1:0] ada;
pgbh pg1(start,tc,ena,clk,reset);
counterupN #(M) cnt1(ada,'d0,tc,ena,clk,reset,tc,2**M-1);
DFF df1(start1,clk,reset,start);
DFF df2(start2,clk,reset,start1);

QRpart2 #(N) QR2(clk,reset,start2,R1,R2,R3,R4,R5,R6,R7,R8,
            R1out,R2out,R3out,R4out,R5out,R6out,R7out,R8out);
ROM_block #(N,M) mem(clk,ada,ena,R1,R2,R3,R4,R5,R6,R7,R8);
endmodule

module QRpart2 #(parameter N=18)(clk,reset,start,R1,R2,R3,R4,R5,R6,R7,R8,
            R1out,R2out,R3out,R4out,R5out,R6out,R7out,R8out);
input clk,reset,start;
input [N-1:0] R1,R2,R3,R4;
input [N-1:0] R5,R6,R7,R8;
output [N-1:0] R1out,R2out,R3out,R4out;
output [N-1:0] R5out,R6out,R7out,R8out;
wire [N-1:0] R21,R31,R32,R41,R42,R43,R51,R52,R53,R61,R62,R71;
wire start1,start2,start3,start4,end_op1,end_op2,end_op3,end_op4,end_op5,end_op6,end_op7,end_op8,end_op9,end_op10;

DFF f1(start1,clk,reset,start);
DFF f2(start2,clk,reset,start1);
DFF f3(start3,clk,reset,start2);

CORDIC_vec #(N,18'b000000000000000000) c1(R1,R5,R1out,R51,clk,reset,start,end_op1);
CORDIC_vec #(N,18'b000000000000000000) c2(R2,R6,R21,R61,clk,reset,start1,end_op2);
CORDIC_vec #(N,18'b000000000000000000) c3(R3,R7,R31,R71,clk,reset,start2,end_op3);
CORDIC_vec #(N,18'b000000000000000000) c4(R4,R8,R41,R8out,clk,reset,start3,end_op4);

CORDIC_vec #(N,18'b000000000000000000) c5(R21,R51,R2out,R52,clk,reset,end_op2,end_op5);
CORDIC_vec #(N,18'b000000000000000000) c6(R31,R61,R32,R62,clk,reset,end_op3,end_op6);
CORDIC_vec #(N,18'b000000000000000000) c7(R41,R71,R42,R7out,clk,reset,end_op4,end_op7);

CORDIC_vec #(N,18'b000000000000000000) c8(R32,R52,R3out,R53,clk,reset,end_op6,end_op8);
CORDIC_vec #(N,18'b000000000000000000) c9(R42,R62,R43,R6out,clk,reset,end_op7,end_op9);

CORDIC_vec #(N,18'b000000000000000000) c10(R43,R53,R4out,R5out,clk,reset,end_op9,end_op10);
endmodule


module counterupN #(parameter N = 10)(count,data,load,en,clk,reset,tc,lmt);
output [N-1:0] count;
output reg tc;
input [N-1:0] data,lmt;
input load, en, clk,reset;
reg [N-1:0] count;

always @(posedge clk)
if (reset) begin
  count <= 1'b0 ;
end else if (load) begin
  count <= data;
end else if (en)
  count <= count + 1'b1;
else count <= count;
always @*
if (count ==lmt)
tc=1;
else tc=0;
endmodule

module pgbh(start,stop,q,clk,reset);
	 input start,stop,clk,reset;
	 output reg q;
	 
always @(posedge clk)
begin
if (reset)
q = 0;
else if (start)
q = 1'b1;
else if(stop)
q = 1'b0;
end
endmodule

module ROM_block #(parameter N=18,M=4)(clk,ada,ena,R1,R2,R3,R4,R5,R6,R7,R8);
input [M-1:0] ada;
input clk,ena;
output [N-1:0] R1,R2,R3,R4,R5,R6,R7,R8;
ROM1 #(N,M) m1(ada,ena,clk,R1);
ROM2 #(N,M) m2(ada,ena,clk,R2);
ROM3 #(N,M) m3(ada,ena,clk,R3);
ROM4 #(N,M) m4(ada,ena,clk,R4);
ROM5 #(N,M) m5(ada,ena,clk,R5);
ROM6 #(N,M) m6(ada,ena,clk,R6);
ROM7 #(N,M) m7(ada,ena,clk,R7);
ROM8 #(N,M) m8(ada,ena,clk,R8);
endmodule

module ROM1 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R1.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM2 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R2.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM3 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R3.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM4 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R4.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM5 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R5.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM6 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R6.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM7 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R7.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM8 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R8.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule